org.vishia.gral.swt

## Class SwtButton

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess
  - - org.vishia.gral.base.GralButton.GraphicImplAccess
    - - org.vishia.gral.swt.SwtButton

- All Implemented Interfaces:
    GralWidgImpl_ifc

      public class SwtButton
      extends GralButton.GraphicImplAccess

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `SwtButton.KeyListener`
    `private class` | `SwtButton.SwtButtonImpl`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) org.eclipse.swt.graphics.Color` | `black`
    `(package private) org.eclipse.swt.graphics.Font` | `fontText`
    `(package private) SwtGralMouseListener.MouseListenerGralAction` | `mouseListener`
    `private SwtWidgetHelper` | `swtWidgHelper` It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.
    `static int` | `version` Version, history and license.
    `(package private) org.eclipse.swt.graphics.Color` | `white`
    `(package private) org.eclipse.swt.widgets.Canvas` | `widgetSwt`

    - ### Fields inherited from class org.vishia.gral.base.GralButton.GraphicImplAccess

      `colorgback, colorgline, mouseWidgetAction, sButtonText, widgg`

    - ### Fields inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `chgBitsDerived, chgColorBack, chgColorLine, chgColorText, chgEditable, chgFloat, chgFocus, chgFont, chgIntg, chgInvisible, chgObjects, chgPos, chgText, chgVisible, chgVisibleInfo, pixBounds, wdgimpl`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SwtButton(GralButton widgg, SwtMng mng)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralRectangle` | `getPixelPositionSize()`
    `java.lang.Object` | `getWidgetImplementation()` Returns the implementation class of the widget.
    `protected void` | `paintRoutine(org.eclipse.swt.events.PaintEvent e, org.eclipse.swt.widgets.Canvas canvas)`
    `void` | `removeWidgetImplementation()` Removes the graphical widget in the graphic.
    `void` | `repaintGthread()` This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
    `(package private) void` | `setBoundsGraphic(GralPos pos, SwtMng mng)`
    `void` | `setBoundsPixel(int x, int y, int dx, int dy)`
    `boolean` | `setFocusGThread()` Sets the focus to the widget.
    `void` | `setVisibleGThread(boolean bVisible)` Sets the implementation widget vible or not.

    - ### Methods inherited from class org.vishia.gral.base.GralButton.GraphicImplAccess

      `isPressed, paint1, prepareWidget`

    - ### Methods inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `acknChanged, actionShow, dyda, getActionChange, getChanged, gralWidgetFromImplData, setDragEnable, setDropEnable, setFocused, setTextChanged, setVisibleState, XXXfocusGained`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### version

          public static final int version

      Version, history and license.
      - 2013-12-22 Hartmut chg: Now `GralButton` uses the new concept of instantiation: It is not the super class of the implementation class. But it provides `GralButton.GraphicImplAccess` as the super class.
      - 2012-03-09 Hartmut new setFocus on press button
      - 2012-03-09 Hartmut new 3-state-Button.
      - 2012-03-09 Hartmut improved: appearance of the buttons.
      - All other changes in 2010, 2011
      Copyright/Copyleft:
      For this source the LGPL Lesser General Public License, published by the Free Software Foundation is valid. It means:
      1. You can use this source without any restriction for any desired purpose.
      2. You can redistribute copies of this source to everybody.
      3. Every user of this source, also the user of redistribute copies with or without payment, must accept this license for further using.
      4. But the LPGL is not appropriate for a whole software product, if this source is only a part of them. It means, the user must publish this part of source, but doesn't need to publish the whole source of the own product.
      5. You can study and modify (improve) this source for own using or for redistribution, but you have to license the modified sources likewise under this LGPL Lesser General Public License. You mustn't delete this Copyright/Copyleft inscription in this source file.
      If you intent to use this source without publishing its usage, you can get a second license subscribing a special contract with the author.
      See Also:
        Constant Field Values

    - #### swtWidgHelper

          private final SwtWidgetHelper swtWidgHelper

      It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.

    - #### widgetSwt

          org.eclipse.swt.widgets.Canvas widgetSwt

    - #### black

          final org.eclipse.swt.graphics.Color black

    - #### white

          final org.eclipse.swt.graphics.Color white

    - #### fontText

          final org.eclipse.swt.graphics.Font fontText

    - #### mouseListener

          final SwtGralMouseListener.MouseListenerGralAction mouseListener

  - ### Constructor Detail

    - #### SwtButton

          SwtButton(GralButton widgg,
                    SwtMng mng)

  - ### Method Detail

    - #### getPixelPositionSize

          public GralRectangle getPixelPositionSize()

    - #### setBoundsGraphic

          void setBoundsGraphic(GralPos pos,
                                SwtMng mng)

    - #### removeWidgetImplementation

          public void removeWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Removes the graphical widget in the graphic.

    - #### getWidgetImplementation

          public java.lang.Object getWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Returns the implementation class of the widget. If the widget has more as one implementation widgets, this method returns one of the widgets, usual the first important one respectively that widget which represents the implementation layer. A widget of the implementation layer is a SWT.control or a `Component`.
      If more as one widget are part of the GralWidget, use the special `GralWidget._wdgImpl` class which should contain the references to that implementation widgets.

    - #### setBoundsPixel

          public void setBoundsPixel(int x,
                                     int y,
                                     int dx,
                                     int dy)

    - #### setFocusGThread

          public boolean setFocusGThread()

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the focus to the widget. See `GralMng_ifc#setFocus(GralWidget)`.
      Returns:
        true if it has the focus after this operation. false on any error.

    - #### setVisibleGThread

          public void setVisibleGThread(boolean bVisible)

      Sets the implementation widget vible or not.
      Parameters:
        `bVisible` - true then the widget should be visible, false it is set to invisible.
      See Also:
        `GralWidgImpl_ifc.setVisibleGThread(boolean)`

    - #### repaintGthread

          public void repaintGthread()

      Description copied from interface: `GralWidgImpl_ifc`
      This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
      Implementation hints: In SWT it should call redraw().
      It is possible that the widget consists of more as one graphical widget, then all of it should be redrawn. It is possible that some data are set in another thread, they should be applied to the widgets firstly. It is possible that the widget is removed though a repaintGthread-order is pending from the time before deleting, for example if the graphic layout is changed.
      See `#repaintRequ`

    - #### paintRoutine

          protected void paintRoutine(org.eclipse.swt.events.PaintEvent e,
                                      org.eclipse.swt.widgets.Canvas canvas)